{ config, inputs, lib, outputs, pkgs, ... }: {
  boot = {
    initrd.kernelModules = [ "zfs" ];
    kernelPackages = pkgs.linuxPackages_6_18;
    loader = {
      efi.canTouchEfiVariables = true;
      systemd-boot = {
        enable = true;
        memtest86.enable = true;
      };
      timeout = 3;
    };
    supportedFilesystems = [ "zfs" ];
    zfs = {
      devNodes = "/dev/disk/by-label";
      forceImportRoot = false;
      package = pkgs.zfs_2_4;
    };
  };

  environment.systemPackages = [
    pkgs.git-review
  ];

  imports = [
    ./disks.nix
    ./hardware-configuration.nix
    ../common/core
    #../common/optional/db.nix
    ../common/optional/dev.nix
    ../common/optional/gui.nix
    ../common/optional/misc.nix
    #../common/optional/multimedia.nix
    ../common/optional/pipewire.nix
    ../common/optional/services/openssh.nix
    ../common/optional/services/xorg.nix
    ../common/optional/zfs.nix
    ../common/users/nipsy
    ../common/users/root
  ];

  networking = {
    hostId = "4b1f6e29";
    hostName = "kaitain";
    nftables.enable = true;
  };

  nixpkgs = {
    config.allowUnfree = true;
    hostPlatform = "x86_64-linux";
    overlays = [
      outputs.overlays.additions
      outputs.overlays.modifications
      outputs.overlays.master-packages
      outputs.overlays.stable-packages
    ];
  };

  services.openssh.openFirewall = false;
  services.xserver.videoDrivers = lib.mkForce [ "modesetting" ];

  sops = {
    age.sshKeyPaths = [ "/etc/ssh/ssh_host_ed25519_key" ];
    defaultSopsFile = ../secrets/kaitain.yaml;

    secrets = {
      "nix-access-token-github" = {};
      "ssh_config".path = "/root/.ssh/config";
    };
  };

  system.stateVersion = "23.11";

  #systemd.user.services = let
  #  vbox-client = desc: flags: {
  #    description = "VirtualBox Guest: ${desc}";

  #    wantedBy = [ "graphical-session.target" ];
  #    requires = [ "dev-vboxguest.device" ];
  #    after = [ "dev-vboxguest.device" ];

  #    unitConfig.ConditionVirtualization = "oracle";

  #    serviceConfig.ExecStart = "${config.boot.kernelPackages.virtualboxGuestAdditions}/bin/VBoxClient -fv ${flags}";
  #    };
  #in {
  #  virtualbox-resize = vbox-client "Resize" "--vmsvga";
  #  virtualbox-clipboard = vbox-client "Clipboard" "--clipboard";
  #};

  users.users.root.openssh.authorizedKeys.keys = [
    (builtins.readFile ../common/users/nipsy/keys/id_att.pub)
  ];

  virtualisation.hypervGuest.enable = true;
}
